;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Tross Intro Editor
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\comdlg32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\comdlg32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
;##########################################################################
;##########################################################################
	CurDate		TEXTEQU	<">, @Date, <">
	CurTime		TEXTEQU	<">, @Time, <">
	CurFileName	TEXTEQU	<">, @FileCur, <">
;##########################################################################
DlgProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ParseSrc	PROTO	:PTR BYTE,:PTR BYTE
ParseDest	PROTO	:PTR BYTE,:PTR BYTE
LoadFile	PROTO	:PTR BYTE
SaveFile	PROTO	:PTR BYTE
ustr2dw		PROTO
FreeRes		PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle	db		"Tross Intro Editor", 0
	szMsgAbout	db		"Tross Intro Editor", 13, 10
			db		"Version 1.0", 13, 10
			db		"Built on ", CurDate, " ", CurTime, 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://euro.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"http://comrade.ownz.com/", 13, 10
			db		"http://comrade.win32asm.com/", 13, 10
			db		"http://comrade.hpacv.dk/", 13, 10
			db		"http://www.comrade64.com/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 0
	szMenuAbout	db		"&About Tross Intro Editor...", 0
	szFileFilter	db		"Executables (*.exe)", 0, "*.exe", 0, "All Files (*.*)", 0, "*.*", 0, 0
	szErrorLoadFail	db		"Error loading file!", 0
	szErrorSaveFail	db		"Error saving file!", 0
	szError		db		"Error", 0
	szErrorThread	db		"Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 0
	szErrorFinal	db		"Error at %08Xh", 13, 10, "Quitting...", 0
	szPageFormat	db		"#%02lu", 0
	szColourFormat	db		"<c%02lu>", 0
;##########################################################################
.data
;##########################################################################
.data?
	hIcon		dd		?
	hIconOpen	dd		?
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)

	data_start	equ		$
	mbp		MSGBOXPARAMS	<>
	ofn		OPENFILENAME	<>
	szFileName	db		MAX_PATH dup (?)
	img_dos_hdr	IMAGE_DOS_HEADER <>
	img_nt_hdrs	IMAGE_NT_HEADERS <>
	img_sect_hdr	IMAGE_SECTION_HEADER <>
	dwPages		dd		8 dup (?)
	szPages		db		1024 dup (?)	; 4x256KB
	szPage		db		384 dup (?)
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, eax
	mov	[mbp.hInstance], eax
	mov	[ofn.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR DlgProc, eax
	invoke	ExitProcess, eax
;#########################################################################
DlgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		mov	eax, [hWnd]
		mov	[mbp.hwndOwner], eax
		mov	[ofn.hwndOwner], eax
		invoke	GetSystemMenu, eax, 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu
		invoke	LoadIcon, [lParam], 2
		mov	[hIcon], eax
		invoke	SendMessage, [hWnd], WM_SETICON, 1, eax
		invoke	LoadImage, [lParam], 3, IMAGE_ICON, 16, 16, 0
		mov	[hIconOpen], eax
		invoke	SendDlgItemMessage, [hWnd], 103, BM_SETIMAGE, IMAGE_ICON, eax
		invoke	SendDlgItemMessage, [hWnd], 102, EM_SETLIMITTEXT, sizeof szFileName, 0
		invoke	SendDlgItemMessage, [hWnd], 105, EM_SETLIMITTEXT, sizeof szPage, 0
	.elseif [uMsg]==WM_SYSCOMMAND
		cmp	[wParam], 10
		je	@@msga
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==103	; Browse
			mov	[ofn.lStructSize], sizeof ofn
			mov	[ofn.lpstrFilter], OFFSET szFileFilter
			mov	[ofn.lpstrFile], OFFSET szFileName
			mov	[ofn.nMaxFile], sizeof szFileName
			mov	[ofn.lpstrDefExt], OFFSET szFileFilter+20
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 102, ADDR szFileName
		.elseif eax==(CBN_SELENDOK shl 16 + 104)	; Page
			invoke	SendMessage, [lParam], CB_GETCURSEL, 0, 0
			invoke	SendMessage, [lParam], CB_GETITEMDATA, eax, 0
			invoke	ParseDest, ADDR szPage, eax
			invoke	SetDlgItemText, [hWnd], 105, ADDR szPage
		.elseif eax==(EN_KILLFOCUS shl 16 + 105)	; Page contents
			invoke	GetWindowText, [lParam], ADDR szPage, sizeof szPage
			invoke	SendDlgItemMessage, [hWnd], 104, CB_GETCURSEL, 0, 0
			invoke	SendDlgItemMessage, [hWnd], 104, CB_GETITEMDATA, eax, 0
			invoke	ParseSrc, eax, ADDR szPage
		.elseif ax==110	; Load
			invoke	GetDlgItemText, [hWnd], 102, ADDR szFileName, sizeof szFileName
			invoke	LoadFile, ADDR szFileName
			test	eax, eax
			jnz	@@quit
			invoke	MessageBox, [hWnd], ADDR szErrorLoadFail, ADDR szError, MB_OK OR MB_ICONEXCLAMATION OR MB_APPLMODAL
		.elseif ax==111	; Save
			invoke	GetDlgItemText, [hWnd], 102, ADDR szFileName, sizeof szFileName
			invoke	SaveFile, ADDR szFileName
			test	eax, eax
			jnz	@@quit
			invoke	MessageBox, [hWnd], ADDR szErrorSaveFail, ADDR szError, MB_OK OR MB_ICONEXCLAMATION OR MB_APPLMODAL
		.elseif ax==112	; About
		@@msga:	mov	[mbp.cbSize], sizeof mbp
			mov	[mbp.lpszText], OFFSET szMsgAbout
			mov	[mbp.lpszCaption], OFFSET szAppTitle
			mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
			mov	[mbp.lpszIcon], 2
			invoke	MessageBoxIndirect, ADDR mbp
		.elseif ax==113	; Close
			invoke	SendMessage, [hWnd], WM_CLOSE, 0, 0
		.endif
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
		call	FreeRes
	.endif
@@quit:	xor	eax, eax
	ret
DlgProc endp
;##########################################################################
ParseSrc proc pszDest:PTR BYTE, pszSource:PTR BYTE
	push	esi
	push	edi
	push	ebx
	mov	esi, [pszSource]
	mov	edi, [pszDest]
	jmp	@@chkz
@@next:	mov	eax, [esi]
	cmp	ax, "c<"	; colour
	jne	@@cmpb
	mov	byte ptr [edi], 01h
	inc	edi
	add	esi, 2
	call	ustr2dw
	inc	esi
	stosb
	movzx	eax, byte ptr [esi]
	jmp	@@chkz
@@cmpb:	and	eax, 00FFFFFFh
	cmp	eax, ">b<"	; bold
	jne	@@cmpu
	add	esi, 2
	mov	byte ptr [esi], 02h
@@cmpu:	cmp	eax, ">u<"	; underline
	jne	@@cmpn
	add	esi, 2
	mov	byte ptr [esi], 03h
@@cmpn:	and	eax, 0000FFFFh
	cmp	eax, 0A0Dh	; newline
	jne	@@copy
	inc	esi
	mov	byte ptr [esi], 0Ah
@@copy:	xor	eax, eax
	lodsb
	stosb
@@chkz:	test	eax, eax
	jne	@@next
	pop	ebx
	pop	edi
	pop	esi
	ret
ParseSrc endp
;##########################################################################
ParseDest proc pszDest:PTR BYTE, pszSource:PTR BYTE
	push	esi
	push	edi
	push	ebx
	mov	esi, [pszSource]
	mov	edi, [pszDest]
	jmp	@@chkz
@@next:	movzx	eax, byte ptr [esi]
	cmp	eax, 01h	; colour
	jne	@@cmpb
	inc	esi
	movzx	eax, byte ptr [esi]
	invoke	wsprintf, ADDR szMessage, ADDR szColourFormat, eax
	mov	eax, dword ptr [szMessage+00h]
	mov	ecx, dword ptr [szMessage+04h]
	mov	[edi+00h], eax
	mov	[edi+04h], ecx
	inc	esi
	add	edi, 5
	movzx	eax, byte ptr [esi]
	jmp	@@chkz
@@cmpb:	cmp	eax, 02h	; bold
	jne	@@cmpu
	inc	esi
	mov	dword ptr [edi], ">b<"
	add	edi, 3
	movzx	eax, byte ptr [esi]
	jmp	@@chkz
@@cmpu:	cmp	eax, 03h	; underline
	jne	@@cmpn
	inc	esi
	mov	dword ptr [edi], ">u<"
	add	edi, 3
	movzx	eax, byte ptr [esi]
	jmp	@@chkz
@@cmpn:	cmp	eax, 0Ah	; newline
	jne	@@copy
	inc	esi
	mov	word ptr [edi], 0A0Dh
	add	edi, 2
	movzx	eax, byte ptr [esi]
	jmp	@@chkz
@@copy:	xor	eax, eax
	lodsb
	stosb
@@chkz:	test	eax, eax
	jne	@@next
	pop	ebx
	pop	edi
	pop	esi
	ret
ParseDest endp
;##########################################################################
LoadFile proc pszFileName:PTR BYTE
	LOCAL hFileIn:DWORD
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	push	edi
	push	esi
	push	ebx
	invoke	CreateFile, [pszFileName], GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0
	mov	[hFileIn], eax
	inc	eax
	jz	@@done
	invoke	ReadFile, [hFileIn], ADDR img_dos_hdr, sizeof img_dos_hdr, esp, 0
	test	eax, eax
	jz	@@done
	xor	eax, eax
	cmp	[img_dos_hdr.e_magic], "ZM"
	jne	@@done
	invoke	SetFilePointer, [hFileIn], [img_dos_hdr.e_lfanew], 0, FILE_BEGIN
	inc	eax
	jz	@@done
	invoke	ReadFile, [hFileIn], ADDR img_nt_hdrs, sizeof img_nt_hdrs, esp, 0
	test	eax, eax
	jz	@@done
	xor	eax, eax
	cmp	[img_nt_hdrs.Signature], "EP"
	jne	@@done
	movzx	ebx, [img_nt_hdrs.FileHeader.NumberOfSections]
@@s00a:	invoke	ReadFile, [hFileIn], ADDR img_sect_hdr, sizeof img_sect_hdr, esp, 0
	cmp	dword ptr [img_sect_hdr.Name1+00h], "tni."
	jne	@@s00b
	cmp	dword ptr [img_sect_hdr.Name1+04h], "or"
	je	@@sect
@@s00b:	dec	ebx
	jnz	@@s00a
	mov	eax, ebx
	jmp	@@done
@@sect:	invoke	SetFilePointer, [hFileIn], [img_sect_hdr.PointerToRawData], 0, FILE_BEGIN
	invoke	ReadFile, [hFileIn], ADDR dwPages, sizeof dwPages+sizeof szPages, esp, 0
	test	eax, eax
	jz	@@done
	invoke	SendDlgItemMessage, [mbp.hwndOwner], 104, CB_RESETCONTENT, 0, 0
	mov	esi, OFFSET dwPages
	xor	ebx, ebx
@@page:	lodsd
	test	eax, eax
	jz	@@nopg
	sub	eax, [img_nt_hdrs.OptionalHeader.ImageBase]
	sub	eax, [img_sect_hdr.VirtualAddress]
	add	eax, OFFSET dwPages
	push	eax	; for CB_SETITEMDATA
	inc	ebx
	invoke	wsprintf, ADDR szMessage, ADDR szPageFormat, ebx
	invoke	SendDlgItemMessage, [mbp.hwndOwner], 104, CB_ADDSTRING, 0, ADDR szMessage
	push	eax
	push	CB_SETITEMDATA
	push	104
	push	[mbp.hwndOwner]
	call	SendDlgItemMessage
	jmp	@@page
@@nopg:	invoke	SendDlgItemMessage, [mbp.hwndOwner], 104, CB_SETCURSEL, eax, eax
	invoke	GetDlgItem, [mbp.hwndOwner], 104
	push	eax	; for EnableWindow()
	push	eax
	invoke	PostMessage, [mbp.hwndOwner], WM_COMMAND, CBN_SELENDOK shl 16 + 104, eax
	call	EnableWindow
	inc	eax
@@done:	pop	ebx
	pop	esi
	pop	edi
@@safe:	pop	FS:[0]
	mov	[esp], eax
	invoke	CloseHandle, [hFileIn]
	pop	eax
	ret
LoadFile endp
;##########################################################################
SaveFile proc pszFileName:PTR BYTE
	LOCAL hFileOut:DWORD
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	push	edi
	push	esi
	push	ebx
	invoke	CreateFile, [pszFileName], GENERIC_READ OR GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0
	mov	[hFileOut], eax
	inc	eax
	jz	@@safe
	invoke	ReadFile, [hFileOut], ADDR img_dos_hdr, sizeof img_dos_hdr, esp, 0
	test	eax, eax
	jz	@@done
	xor	eax, eax
	cmp	[img_dos_hdr.e_magic], "ZM"
	jne	@@done
	invoke	SetFilePointer, [hFileOut], [img_dos_hdr.e_lfanew], 0, FILE_BEGIN
	inc	eax
	jz	@@done
	invoke	ReadFile, [hFileOut], ADDR img_nt_hdrs, sizeof img_nt_hdrs, esp, 0
	test	eax, eax
	jz	@@done
	xor	eax, eax
	cmp	[img_nt_hdrs.Signature], "EP"
	jne	@@done
	movzx	ebx, [img_nt_hdrs.FileHeader.NumberOfSections]
@@s00a:	invoke	ReadFile, [hFileOut], ADDR img_sect_hdr, sizeof img_sect_hdr, esp, 0
	cmp	dword ptr [img_sect_hdr.Name1+00h], "tni."
	jne	@@s00b
	cmp	dword ptr [img_sect_hdr.Name1+04h], "or"
	je	@@sect
@@s00b:	dec	ebx
	jnz	@@s00a
	mov	eax, ebx
	jmp	@@done
@@sect:	invoke	SetFilePointer, [hFileOut], [img_sect_hdr.PointerToRawData], 0, FILE_BEGIN
	invoke	WriteFile, [hFileOut], ADDR dwPages, sizeof dwPages+sizeof szPages, esp, 0
	test	eax, eax
	jz	@@done
	inc	eax
@@done:	pop	ebx
	pop	esi
	pop	edi
@@safe:	pop	FS:[0]
	mov	[esp], eax
	invoke	CloseHandle, [hFileOut]
	pop	eax
	ret
SaveFile endp
;##########################################################################
ustr2dw proc
	xor	eax, eax
	xor	edx, edx
	jmp	@@chkz
@@redo:	cmp	dl, "9"
	ja	@@quit
	cmp	dl, "0"
	jb	@@quit
	sub	dl, "0"
	mov	ecx, eax
	add	eax, eax
	shl	ecx, 3
	inc	esi
	add	eax, ecx
	add	eax, edx
@@chkz:	mov	dl, [esi]
	test	dl, dl
	jnz	@@redo
@@quit:	ret
ustr2dw endp
;##########################################################################
FreeRes proc
	invoke	DestroyIcon, [hIcon]
	invoke	DestroyIcon, [hIconOpen]
	ret
FreeRes endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	invoke	EndDialog, [mbp.hwndOwner], eax
	call	FreeRes
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start