;******************************************************************************/
;* MINIFMOD.H                                                                 */
;* ----------------                                                           */
;* MiniFMOD public source code release.                                       */
;* This source is provided as-is.  Firelight Multimedia will not support      */
;* or answer questions about the source provided.                             */
;* MiniFMOD Sourcecode is copyright (c) 2000, Firelight Multimedia.           */
;* MiniFMOD Sourcecode is in no way representative of FMOD 3 source.          */
;* Firelight Multimedia is a registered business name.                        */
;* This source must not be redistributed without this notice.                 */
;******************************************************************************/

;==========================================================================================
; MINIFMOD Main header file. Copyright (c), FireLight Multimedia 2000.
; Based on FMOD, copyright (c), FireLight Multimedia 2000.
;==========================================================================================

;===============================================================================================
;= DEFINITIONS
;===============================================================================================

; fmod defined types
;typedef struct FMUSIC_MODULE	FMUSIC_MODULE;

;===============================================================================================
;= FUNCTION PROTOTYPES
;===============================================================================================

; ==================================
; Initialization / Global functions.
; ==================================
;typedef void (*SAMPLELOADCALLBACK)(void *buff, int lenbytes, int numbits, int instno, int sampno);
;typedef void (*FMUSIC_CALLBACK)(FMUSIC_MODULE *mod, unsigned char param);

; this must be called before FSOUND_Init!
FSOUND_File_SetCallbacks	PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
FSOUND_Init			PROTO	:DWORD,:DWORD
FSOUND_Close			PROTO

; =============================================================================================
; FMUSIC API
; =============================================================================================

; Song management / playback functions.
; =====================================
FMUSIC_LoadSong			PROTO	:DWORD,:DWORD
FMUSIC_FreeSong			PROTO	:DWORD
FMUSIC_PlaySong			PROTO	:DWORD
FMUSIC_StopSong			PROTO	:DWORD

; Runtime song information.
; =========================
FMUSIC_GetOrder			PROTO	:DWORD
FMUSIC_GetRow			PROTO	:DWORD
FMUSIC_GetTime			PROTO	:DWORD